/**
 * \file
 *
 * \author Mattia Basaglia
 *
 * \copyright Copyright (C) 2016-2017 Mattia Basaglia
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "backend/common/backend.hpp"
#include "backend/common/types.hpp"
#include "engine/log.hpp"

#line 26 "@CMAKE_SOURCE_DIR@/src/backend/common/backend_load.in.cpp"


/// \note Generated by CMake
void backend::Backend::load_factories()
{
    if ( !_factories_loaded )
    {
        @BACKEND_FORWARD_CODE@
        using LoadFunction = void (*)();
        LoadFunction functions[] = {
            @BACKEND_LOADING_CODE@
        };
        for ( auto funcptr : functions )
        {
            try {
                funcptr();
            } catch ( const engine::Error& e ) {
                logging::warning(e.origin()) <<  e.what();
            }
        }
        _factories_loaded = true;
    }
}

bool backend::Backend::_factories_loaded = false;
